package com.ruoyi.web.controller.system;

import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.system.domain.UpdateApp;
import com.ruoyi.system.service.IUpdateAppService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * 【请填写功能名称】Controller
 * 
 * @author ruoyi
 * @date 2023-02-16
 */
@RestController
@RequestMapping("/system/app")
public class UpdateAppController extends BaseController
{
    @Autowired
    private IUpdateAppService updateAppService;

    /**
     * 查询【请填写功能名称】列表
     */
    @GetMapping("/list")
    public TableDataInfo list(UpdateApp updateApp)
    {
        startPage();
        List<UpdateApp> list = updateAppService.selectUpdateAppList(updateApp);
        return getDataTable(list);
    }

    /**
     * 导出【请填写功能名称】列表
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, UpdateApp updateApp)
    {
        List<UpdateApp> list = updateAppService.selectUpdateAppList(updateApp);
        ExcelUtil<UpdateApp> util = new ExcelUtil<UpdateApp>(UpdateApp.class);
        util.exportExcel(response, list, "【请填写功能名称】数据");
    }

    /**
     * 获取【请填写功能名称】详细信息
     */
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id)
    {
        return success(updateAppService.selectUpdateAppById(id));
    }

    /**
     * 新增【请填写功能名称】
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody UpdateApp updateApp)
    {
        return toAjax(updateAppService.insertUpdateApp(updateApp));
    }

    /**
     * 修改【请填写功能名称】
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.UPDATE)
    @PostMapping("/put")
    public AjaxResult edit(@RequestBody UpdateApp updateApp)
    {
        return toAjax(updateAppService.updateUpdateApp(updateApp));
    }

    /**
     * 删除【请填写功能名称】
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.DELETE)
	@GetMapping("/delete/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids)
    {
        return toAjax(updateAppService.deleteUpdateAppByIds(ids));
    }

    /**
     * 获取当前最新版本数据
     */
    @GetMapping(value = "/new")
    public AjaxResult getInfoNew(UpdateApp updateApp)
    {
        return success(updateAppService.getInfoNew(updateApp));
    }
}
